﻿/***************************************************************/
//ゲームを管理する
/***************************************************************/
using UnityEngine;
using System.Collections;

//ゲームのモード
enum GameMode { 
    Fade = 0,   //フェード中
    Start = 1,  //スタート状態
    Play = 2,   //少女動き中
    Goal = 3,   //ゴール
    Dead = 4,   //死亡
}

public class GameManager : MonoBehaviour {
    //ゲームの状態
    [SerializeField]
    private int state = (int)GameMode.Fade;

    //カウントダウンの時間
    [SerializeField]
    private float MaxCountDownTime=30.0f;

    //カウントダウン用のタイマー
    [SerializeField]
    private float time=0.0f;

    [SerializeField]
    private GameObject resultImage;


	// Use this for initialization
	void Start () {
	}

    // Update is called once per frame
    void Update()
    {
        //カウントダウンをする
        CountDown();
        //死んでいたら
        Dead();

        //リザルトへ
        Result();

        //test2
        if (Input.GetKeyDown(KeyCode.Z)) state = (int)GameMode.Dead;

        if (Input.GetKeyDown(KeyCode.M)) Application.LoadLevel("StageSelect");
    }

    //カウントダウンをする
    void CountDown()
    {
        if (state != (int)GameMode.Start) return;
        time += 1.0f * Time.deltaTime;

        //ゲームスタート
        if (time >= MaxCountDownTime) {
			state = (int)GameMode.Play;

			// 少女ＡＩを取得
			GameObject go = GameObject.FindWithTag("Girl");
			if (go != null)	{
				GirlAI girl = go.GetComponent<GirlAI>();
				// 少女ＡＩを移動状態へ
				if (girl != null)	girl.ChangeState( new StateMove() );
			}
		}
    }

    //死んでいたら
    void Dead()
    {
        if (state != (int)GameMode.Dead) return;

        Application.LoadLevel(Application.loadedLevelName);
    }

    //リザルト
    void Result()
    {
        if (state != (int)GameMode.Goal) return;

        resultImage.active = true;
    }

    //ゲームスタート
    public void GameStart() { state = (int)GameMode.Start; }

    //ゴール
    public void Goal() {
        GameObject menuFade = GameObject.FindGameObjectWithTag("MenuFade");
        state = (int)GameMode.Goal;
        menuFade.GetComponent<Fade>().isFade = true;
    }


    //プレイヤーの移動
    public void PlayerDead()
    {
        state = (int)GameMode.Dead;
    }

    //カウントダウンの時間を返す
    public int getCountDownTime(){ return (int)MaxCountDownTime-(int)time; }
}
