﻿//------------------------------------------------------------------------
// ● 使用ライブラリの宣言
//------------------------------------------------------------------------
using UnityEngine;
//========================================================================
// ■ BaseScripts
//------------------------------------------------------------------------
//	基盤スクリプトのクラス。
//========================================================================

public class BaseScripts : MonoBehaviour {
	//--------------------------------------------------------------------
	// ● メンバ変数
	//--------------------------------------------------------------------
	static BaseScripts instance;	// 自身のインスタンス
	public int generateStageNumber = 0;
	//--------------------------------------------------------------------
	// ● ゲッター
	//--------------------------------------------------------------------
	// 自身を取得
	public static BaseScripts getInstance() {
		// 作成されていない場合
		if (!instance) {
			GameObject prefab =
				(GameObject)Resources.Load("BaseScript");
			DontDestroyOnLoad(prefab);	// 保存登録
			instance = prefab.GetComponent<BaseScripts>();	// 作成されたとする
		}
		return instance;
	}
	//--------------------------------------------------------------------
	// ● 初期化（早）
	//--------------------------------------------------------------------
	void Awake() {
/*
		// 作成されていない場合
		if (!instance) {
			GameObject prefab =
				(GameObject)Resources.Load("Prefabs/BaseScript");
			DontDestroyOnLoad(prefab);	// 保存登録
			instance = prefab.GetComponent<BaseScripts>();	// 作成されたとする

		// 既に作成されている場合
		} else
			Destroy(gameObject);	// 削除
*/
	}
	//--------------------------------------------------------------------
	// ● 更新
	//--------------------------------------------------------------------
	void Update() {
		// ESC キーで終了
//		if ( Input.GetKeyDown(KeyCode.Escape) )	Application.Quit();
	}
	//--------------------------------------------------------------------
	// ● オブジェクト削除
	//	MonoBehaviour を継承しないクラスから Destroy を呼び出せない為、作成。
	//--------------------------------------------------------------------
	public void destroy(string name) {
		Destroy( GameObject.Find(name) );
	}
}