﻿//------------------------------------------------------------------------
// ● 使用ライブラリの宣言
//------------------------------------------------------------------------
using UnityEngine;
using System.Collections;
//========================================================================
// ■ BoarAI
//------------------------------------------------------------------------
//	猪のＡＩクラス。
//========================================================================

public class BoarAI : BaseCharacter {
	//--------------------------------------------------------------------
	// ● メンバ変数
	//--------------------------------------------------------------------
	protected StateBase stateTop;
	float choiceNextStateSecond;
	//--------------------------------------------------------------------
	// ● 初期化
	//--------------------------------------------------------------------
	protected override void Start() {
		base.Start();

		ChangeState( new StateMove() );
		ChangeStateTop( new StateMove() );
//		ChoiceNextState();
	}
	//--------------------------------------------------------------------
	// ● 状態を変更
	//--------------------------------------------------------------------
	public void ChangeStateTop(StateBase newState) {
		// 前回状態を終了
		if (stateTop != null)	stateTop.MyFinalize();
		stateTop = newState;	// 現在状態に適用
		stateTop.ai = this;		// 自身を登録
		stateTop.Initialize();	// 初期化
	}
	//--------------------------------------------------------------------
	// ● 次の状態を選択設定
	//--------------------------------------------------------------------
	void ChoiceNextState() {
		choiceNextStateSecond = Time.time + Random.Range(1, 5);
		
		switch ( Random.Range(0, 5) ) {
			case 0:	ChangeStateTop( new StateMove() );			break;
			case 1:	ChangeStateTop( new StateRotate180() );		break;
			case 2:	ChangeStateTop( new StateRotateLeft90() );	break;
			case 3:	ChangeStateTop( new StateRotateRight90() );	break;
			case 4:	ChangeStateTop( new StateWait() );			break;
		}
		Debug.Log("set" + stateTop);
	}
	//--------------------------------------------------------------------
	// ● 更新
	//--------------------------------------------------------------------
	protected override void Update() {
		// 標識に引っ掛かっている場合
		if ( state.GetType() != typeof(StateMove) ) {
			state.Update();

		// 標識に引っ掛かってない場合
		} else {
			stateTop.Update();
		}

		controller.SimpleMove(moveVector);
		animator.SetFloat("MoveDistance", moveVector.magnitude);

//		UpdateWander();
	}
	//--------------------------------------------------------------------
	// ● 更新（徘徊）
	//--------------------------------------------------------------------
	void UpdateWander() {
		if (choiceNextStateSecond <= Time.time)
			ChoiceNextState();
	}
	//--------------------------------------------------------------------
	// ● 新たに範囲衝突したコールバック関数
	//--------------------------------------------------------------------
	void OnTriggerEnter(Collider collider) {
		if (state == null)
			return;

		if (collider.transform.root == transform)
			return;

		if ( state.GetType() == typeof(StateEternalWait) )
			return;

		GirlAI girl = collider.gameObject.GetComponent<GirlAI>();
		Player player = collider.gameObject.GetComponent<Player>();

		// 少女かプレイヤーと衝突した場合
		if (girl != null || player != null) {
			// プレイヤー死亡を設定
			GameManager gm = GameObject.FindWithTag("GameManager")
				.GetComponent<GameManager>();
			gm.PlayerDead();

		// 標識と衝突した場合
		} else if (collider.gameObject.tag == "TrafficSign") {
			// 何もしない

		// その他障害物と衝突した場合
		} else if ( state.GetType() != typeof(StateRotate180) )
			ChangeState( new StateRotate180() );	// Ｕターン
	}
}