﻿//------------------------------------------------------------------------
// ● 使用ライブラリの宣言
//------------------------------------------------------------------------
using UnityEngine;
using System.Collections;
//========================================================================
// ■ StateRotate180
//------------------------------------------------------------------------
//	キャラクターの180度回転状態クラス。
//========================================================================

public class StateRotate180 : StateBase {
	//--------------------------------------------------------------------
	// ● メンバ変数
	//--------------------------------------------------------------------
	Quaternion defaultRotation;
	protected float maxAngle;
	protected float direction;
	float deltaAngle;
	//--------------------------------------------------------------------
	// ● 初期化
	//--------------------------------------------------------------------
	override public void Initialize() {
		base.Initialize();
		
		defaultRotation = ai.transform.rotation;
		maxAngle = 180;
		direction = 1;
		
		ai.moveVector = Vector3.zero;
	}
	//--------------------------------------------------------------------
	// ● 更新
	//--------------------------------------------------------------------
	override public void Update() {
		base.Update();

		float rotateSpeed = ai.defaultRotateSpeed * direction * Time.deltaTime;

		ai.transform.rotation *= Quaternion.Euler(
			0, rotateSpeed, 0);
		deltaAngle += rotateSpeed;

		if ( Mathf.Abs(deltaAngle) >= Mathf.Abs(maxAngle) )
			ai.ChangeState( new StateMove() );
	}
	//--------------------------------------------------------------------
	// ● 終了
	//--------------------------------------------------------------------
	override public void MyFinalize() {
		base.MyFinalize();
		
		ai.transform.rotation = defaultRotation *
			Quaternion.Euler(0, maxAngle, 0);
	}
}