﻿//------------------------------------------------------------------------
// ● 使用ライブラリの宣言
//------------------------------------------------------------------------
using UnityEngine;
using System.Collections;
//========================================================================
// ■ DirectionCursor
//------------------------------------------------------------------------
//	移動方向カーソルのクラス。
//========================================================================

public class DirectionCursor : MonoBehaviour {
	//--------------------------------------------------------------------
	// ● 定数
	//--------------------------------------------------------------------
	const float WAVE_CYCLE = 0.5f;						// サイン波の周期
	const float WAVE_RATE = Mathf.PI * 2 / WAVE_CYCLE;	// サイン波の１フレーム分の比率
	//--------------------------------------------------------------------
	// ● メンバ変数
	//--------------------------------------------------------------------
	float count;
	//--------------------------------------------------------------------
	// ● 初期化
	//--------------------------------------------------------------------
	void Start() {
		count = WAVE_CYCLE / 2;	// 周期の途中からカウント開始
	}
	//--------------------------------------------------------------------
	// ● 更新
	//--------------------------------------------------------------------
	void Update() {
		Vector3 up = transform.up;
		up *= Mathf.Sin(count * WAVE_RATE) / 200;	// サイン波で前後移動
		transform.position += up;
		count = (count + Time.deltaTime) % WAVE_CYCLE;	// カウントを更新
	}
}