﻿//------------------------------------------------------------------------
// ● 使用ライブラリの宣言
//------------------------------------------------------------------------
using UnityEngine;
using System.Collections;
//========================================================================
// ■ BaseTrafficSign
//------------------------------------------------------------------------
//	交通標識の基盤クラス。
//========================================================================

public class BaseTrafficSign : MonoBehaviour {
	//--------------------------------------------------------------------
	// ● メンバ変数
	//--------------------------------------------------------------------
	protected BaseCharacter ai;
	public bool isValid;
	public string name;
	//--------------------------------------------------------------------
	// ● 初期化
	//--------------------------------------------------------------------
	virtual protected void Start() {
		
	}
	//--------------------------------------------------------------------
	// ● 更新
	//--------------------------------------------------------------------
	virtual protected void Update() {
	}
	//--------------------------------------------------------------------
	// ● 効果を開始
	//--------------------------------------------------------------------
	virtual protected void StartEffect() {
	}
	//--------------------------------------------------------------------
	// ● 新たに範囲衝突したコールバック関数
	//--------------------------------------------------------------------
	void OnTriggerEnter(Collider collider) {
		ai = collider.gameObject.GetComponent<BaseCharacter>();

		if (!isValid && ai != null) {
			isValid = true;
            ai.transform.position = new Vector3(transform.position.x, ai.transform.position.y, transform.position.z);
			StartEffect();
		}
	}
	//--------------------------------------------------------------------
	// ● 範囲衝突中のコールバック関数
	//--------------------------------------------------------------------
	void OnTriggerStay(Collider collider) {
	}
	//--------------------------------------------------------------------
	// ● 範囲衝突から離れたコールバック関数
	//--------------------------------------------------------------------
	void OnTriggerExit(Collider collider) {
		isValid = false;
	}
}